"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
Object.defineProperty(exports, "__esModule", { value: true });
var jsx_dev_runtime_1 = require("react/jsx-dev-runtime");
var _jsxFileName = "/Users/richardmiles/IdeaProjects/react-syntax-highlighter/src/highlight.js";
var react_1 = require("react");
var create_element_1 = require("./create-element");
var checkForListedLanguage_1 = require("./checkForListedLanguage");
var newLineRegex = /\n/g;
function getNewLines(str) {
    return str.match(newLineRegex);
}
function getAllLineNumbers(_a) {
    var _this = this;
    var lines = _a.lines, startingLineNumber = _a.startingLineNumber, style = _a.style;
    return lines.map(function (_, i) {
        var number = i + startingLineNumber;
        return ((0, jsx_dev_runtime_1.jsxDEV)("span", { className: "react-syntax-highlighter-line-number", style: typeof style === 'function' ? style(number) : style, children: "".concat(number, "\n") }, "line-".concat(i), false, { fileName: _jsxFileName, lineNumber: 13, columnNumber: 13 }, _this));
    });
}
function AllLineNumbers(_a) {
    var codeString = _a.codeString, codeStyle = _a.codeStyle, _b = _a.containerStyle, containerStyle = _b === void 0 ? { float: 'left', paddingRight: '10px' } : _b, _c = _a.numberStyle, numberStyle = _c === void 0 ? {} : _c, startingLineNumber = _a.startingLineNumber;
    return ((0, jsx_dev_runtime_1.jsxDEV)("code", { style: Object.assign({}, codeStyle, containerStyle), children: getAllLineNumbers({
            lines: codeString.replace(/\n$/, '').split('\n'),
            style: numberStyle,
            startingLineNumber: startingLineNumber
        }) }, void 0, false, { fileName: _jsxFileName, lineNumber: 32, columnNumber: 11 }, this));
}
function getEmWidthOfNumber(num) {
    return "".concat(num.toString().length, ".25em");
}
function getInlineLineNumber(lineNumber, inlineLineNumberStyle) {
    return {
        type: 'element',
        tagName: 'span',
        properties: {
            key: "line-number--".concat(lineNumber),
            className: [
                'comment',
                'linenumber',
                'react-syntax-highlighter-line-number'
            ],
            style: inlineLineNumberStyle
        },
        children: [
            {
                type: 'text',
                value: lineNumber
            }
        ]
    };
}
function assembleLineNumberStyles(lineNumberStyle, lineNumber, largestLineNumber) {
    // minimally necessary styling for line numbers
    var defaultLineNumberStyle = {
        display: 'inline-block',
        minWidth: getEmWidthOfNumber(largestLineNumber),
        paddingRight: '1em',
        textAlign: 'right',
        userSelect: 'none'
    };
    // prep custom styling
    var customLineNumberStyle = typeof lineNumberStyle === 'function'
        ? lineNumberStyle(lineNumber)
        : lineNumberStyle;
    // combine
    var assembledStyle = __assign(__assign({}, defaultLineNumberStyle), customLineNumberStyle);
    return assembledStyle;
}
function createLineElement(_a) {
    var children = _a.children, lineNumber = _a.lineNumber, lineNumberStyle = _a.lineNumberStyle, largestLineNumber = _a.largestLineNumber, showInlineLineNumbers = _a.showInlineLineNumbers, _b = _a.lineProps, lineProps = _b === void 0 ? {} : _b, _c = _a.className, className = _c === void 0 ? [] : _c, showLineNumbers = _a.showLineNumbers, wrapLongLines = _a.wrapLongLines;
    var properties = typeof lineProps === 'function' ? lineProps(lineNumber) : lineProps;
    properties['className'] = className;
    if (lineNumber && showInlineLineNumbers) {
        var inlineLineNumberStyle = assembleLineNumberStyles(lineNumberStyle, lineNumber, largestLineNumber);
        children.unshift(getInlineLineNumber(lineNumber, inlineLineNumberStyle));
    }
    if (wrapLongLines & showLineNumbers) {
        properties.style = __assign(__assign({}, properties.style), { display: 'flex' });
    }
    return {
        type: 'element',
        tagName: 'span',
        properties: properties,
        children: children
    };
}
function flattenCodeTree(tree, className, newTree) {
    if (className === void 0) { className = []; }
    if (newTree === void 0) { newTree = []; }
    for (var i = 0; i < tree.length; i++) {
        var node = tree[i];
        if (node.type === 'text') {
            newTree.push(createLineElement({
                children: [node],
                className: __spreadArray([], new Set(className), true)
            }));
        }
        else if (node.children) {
            var classNames = className.concat(node.properties.className);
            flattenCodeTree(node.children, classNames).forEach(function (i) { return newTree.push(i); });
        }
    }
    return newTree;
}
function processLines(codeTree, wrapLines, lineProps, showLineNumbers, showInlineLineNumbers, startingLineNumber, largestLineNumber, lineNumberStyle, wrapLongLines) {
    var tree = flattenCodeTree(codeTree.value);
    var newTree = [];
    var lastLineBreakIndex = -1;
    var index = 0;
    function createWrappedLine(children, lineNumber, className) {
        if (className === void 0) { className = []; }
        return createLineElement({
            children: children,
            lineNumber: lineNumber,
            lineNumberStyle: lineNumberStyle,
            largestLineNumber: largestLineNumber,
            showInlineLineNumbers: showInlineLineNumbers,
            lineProps: lineProps,
            className: className,
            showLineNumbers: showLineNumbers,
            wrapLongLines: wrapLongLines
        });
    }
    function createUnwrappedLine(children, lineNumber) {
        if (showLineNumbers && lineNumber && showInlineLineNumbers) {
            var inlineLineNumberStyle = assembleLineNumberStyles(lineNumberStyle, lineNumber, largestLineNumber);
            children.unshift(getInlineLineNumber(lineNumber, inlineLineNumberStyle));
        }
        return children;
    }
    function createLine(children, lineNumber, className) {
        if (className === void 0) { className = []; }
        return wrapLines || className.length > 0
            ? createWrappedLine(children, lineNumber, className)
            : createUnwrappedLine(children, lineNumber);
    }
    var _loop_1 = function () {
        var node = tree[index];
        var value = node.children[0].value;
        var newLines = getNewLines(value);
        if (newLines) {
            var splitValue_1 = value.split('\n');
            splitValue_1.forEach(function (text, i) {
                var lineNumber = showLineNumbers && newTree.length + startingLineNumber;
                var newChild = { type: 'text', value: "".concat(text, "\n") };
                // if it's the first line
                if (i === 0) {
                    var children = tree.slice(lastLineBreakIndex + 1, index).concat(createLineElement({
                        children: [newChild],
                        className: node.properties.className
                    }));
                    var line = createLine(children, lineNumber);
                    newTree.push(line);
                    // if it's the last line
                }
                else if (i === splitValue_1.length - 1) {
                    var stringChild = tree[index + 1] &&
                        tree[index + 1].children &&
                        tree[index + 1].children[0];
                    var lastLineInPreviousSpan = { type: 'text', value: "".concat(text) };
                    if (stringChild) {
                        var newElem = createLineElement({
                            children: [lastLineInPreviousSpan],
                            className: node.properties.className
                        });
                        tree.splice(index + 1, 0, newElem);
                    }
                    else {
                        var children = [lastLineInPreviousSpan];
                        var line = createLine(children, lineNumber, node.properties.className);
                        newTree.push(line);
                    }
                    // if it's neither the first nor the last line
                }
                else {
                    var children = [newChild];
                    var line = createLine(children, lineNumber, node.properties.className);
                    newTree.push(line);
                }
            });
            lastLineBreakIndex = index;
        }
        index++;
    };
    while (index < tree.length) {
        _loop_1();
    }
    if (lastLineBreakIndex !== tree.length - 1) {
        var children = tree.slice(lastLineBreakIndex + 1, tree.length);
        if (children && children.length) {
            var lineNumber = showLineNumbers && newTree.length + startingLineNumber;
            var line = createLine(children, lineNumber);
            newTree.push(line);
        }
    }
    return wrapLines ? newTree : [].concat.apply([], newTree);
}
function defaultRenderer(_a) {
    var rows = _a.rows, stylesheet = _a.stylesheet, useInlineStyles = _a.useInlineStyles;
    return rows.map(function (node, i) {
        return (0, create_element_1.default)({
            node: node,
            stylesheet: stylesheet,
            useInlineStyles: useInlineStyles,
            key: "code-segement".concat(i)
        });
    });
}
// only highlight.js has the highlightAuto method
function isHighlightJs(astGenerator) {
    return astGenerator && typeof astGenerator.highlightAuto !== 'undefined';
}
function getCodeTree(_a) {
    // figure out whether we're using lowlight/highlight or refractor/prism
    // then attempt highlighting accordingly
    var astGenerator = _a.astGenerator, language = _a.language, code = _a.code, defaultCodeValue = _a.defaultCodeValue;
    // lowlight/highlight?
    if (isHighlightJs(astGenerator)) {
        var hasLanguage = (0, checkForListedLanguage_1.default)(astGenerator, language);
        if (language === 'text') {
            return { value: defaultCodeValue, language: 'text' };
        }
        else if (hasLanguage) {
            return astGenerator.highlight(language, code);
        }
        else {
            return astGenerator.highlightAuto(code);
        }
    }
    // must be refractor/prism, then
    try {
        return language && language !== 'text'
            ? { value: astGenerator.highlight(code, language) }
            : { value: defaultCodeValue };
    }
    catch (e) {
        return { value: defaultCodeValue };
    }
}
function default_1(defaultAstGenerator, defaultStyle) {
    return function SyntaxHighlighter(_a) {
        var language = _a.language, children = _a.children, _b = _a.style, style = _b === void 0 ? defaultStyle : _b, _c = _a.customStyle, customStyle = _c === void 0 ? {} : _c, _d = _a.codeTagProps, codeTagProps = _d === void 0 ? {
            className: language ? "language-".concat(language) : undefined,
            style: __assign(__assign({}, style['code[class*="language-"]']), style["code[class*=\"language-".concat(language, "\"]")])
        } : _d, _e = _a.useInlineStyles, useInlineStyles = _e === void 0 ? true : _e, _f = _a.showLineNumbers, showLineNumbers = _f === void 0 ? false : _f, _g = _a.showInlineLineNumbers, showInlineLineNumbers = _g === void 0 ? true : _g, _h = _a.startingLineNumber, startingLineNumber = _h === void 0 ? 1 : _h, lineNumberContainerStyle = _a.lineNumberContainerStyle, _j = _a.lineNumberStyle, lineNumberStyle = _j === void 0 ? {} : _j, wrapLines = _a.wrapLines, _k = _a.wrapLongLines, wrapLongLines = _k === void 0 ? false : _k, _l = _a.lineProps, lineProps = _l === void 0 ? {} : _l, renderer = _a.renderer, _m = _a.PreTag, PreTag = _m === void 0 ? 'pre' : _m, _o = _a.CodeTag, CodeTag = _o === void 0 ? 'code' : _o, _p = _a.code, code = _p === void 0 ? (Array.isArray(children) ? children[0] : children) || '' : _p, astGenerator = _a.astGenerator, rest = __rest(_a, ["language", "children", "style", "customStyle", "codeTagProps", "useInlineStyles", "showLineNumbers", "showInlineLineNumbers", "startingLineNumber", "lineNumberContainerStyle", "lineNumberStyle", "wrapLines", "wrapLongLines", "lineProps", "renderer", "PreTag", "CodeTag", "code", "astGenerator"]);
        astGenerator = astGenerator || defaultAstGenerator;
        var allLineNumbers = showLineNumbers ? ((0, jsx_dev_runtime_1.jsxDEV)(AllLineNumbers, { containerStyle: lineNumberContainerStyle, codeStyle: codeTagProps.style || {}, numberStyle: lineNumberStyle, startingLineNumber: startingLineNumber, codeString: code }, void 0, false, { fileName: _jsxFileName, lineNumber: 345, columnNumber: 47 }, this)) : null;
        var defaultPreStyle = style.hljs ||
            style['pre[class*="language-"]'] || { backgroundColor: '#fff' };
        var generatorClassName = isHighlightJs(astGenerator) ? 'hljs' : 'prismjs';
        var preProps = useInlineStyles
            ? Object.assign({}, rest, {
                style: Object.assign({}, defaultPreStyle, customStyle)
            })
            : Object.assign({}, rest, {
                className: rest.className
                    ? "".concat(generatorClassName, " ").concat(rest.className)
                    : generatorClassName,
                style: Object.assign({}, customStyle)
            });
        if (wrapLongLines) {
            codeTagProps.style = __assign(__assign({}, codeTagProps.style), { whiteSpace: 'pre-wrap' });
        }
        else {
            codeTagProps.style = __assign(__assign({}, codeTagProps.style), { whiteSpace: 'pre' });
        }
        if (!astGenerator) {
            return ((0, jsx_dev_runtime_1.jsxDEV)(PreTag, __assign({}, preProps, { children: [allLineNumbers, (0, jsx_dev_runtime_1.jsxDEV)(CodeTag, __assign({}, codeTagProps, { children: code }), void 0, false, { fileName: _jsxFileName, lineNumber: 379, columnNumber: 11 }, this)] }), void 0, true, { fileName: _jsxFileName, lineNumber: 376, columnNumber: 15 }, this));
        }
        /*
         * Some custom renderers rely on individual row elements so we need to turn wrapLines on
         * if renderer is provided and wrapLines is undefined.
         */
        if ((wrapLines === undefined && renderer) || wrapLongLines)
            wrapLines = true;
        renderer = renderer || defaultRenderer;
        var defaultCodeValue = [{ type: 'text', value: code }];
        var codeTree = getCodeTree({
            astGenerator: astGenerator,
            language: language,
            code: code,
            defaultCodeValue: defaultCodeValue
        });
        if (codeTree.language === null) {
            codeTree.value = defaultCodeValue;
        }
        // determine largest line number so that we can force minWidth on all linenumber elements
        var lineCount = codeTree.value.length;
        if (lineCount === 1 && codeTree.value[0].type === 'text') {
            // Since codeTree for an unparsable text (e.g. 'a\na\na') is [{ type: 'text', value: 'a\na\na' }]
            lineCount = codeTree.value[0].value.split('\n').length;
        }
        var largestLineNumber = lineCount + startingLineNumber;
        var rows = processLines(codeTree, wrapLines, lineProps, showLineNumbers, showInlineLineNumbers, startingLineNumber, largestLineNumber, lineNumberStyle, wrapLongLines);
        return ((0, jsx_dev_runtime_1.jsxDEV)(PreTag, __assign({}, preProps, { children: (0, jsx_dev_runtime_1.jsxDEV)(CodeTag, __assign({}, codeTagProps, { children: [!showInlineLineNumbers && allLineNumbers, renderer({ rows: rows, stylesheet: style, useInlineStyles: useInlineStyles })] }), void 0, true, { fileName: _jsxFileName, lineNumber: 425, columnNumber: 9 }, this) }), void 0, false, { fileName: _jsxFileName, lineNumber: 423, columnNumber: 13 }, this));
    };
}
exports.default = default_1;
//# sourceMappingURL=highlight.js.map