"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var async_syntax_highlighter_1 = require("./async-syntax-highlighter");
var hljs_1 = require("./async-languages/hljs");
var checkForListedLanguage_1 = require("./checkForListedLanguage");
exports.default = (0, async_syntax_highlighter_1.default)({
    loader: function () {
        return Promise.resolve().then(function () { return require(
        /* webpackChunkName:"react-syntax-highlighter/lowlight-import" */
        'lowlight/lib/core'); }).then(function (module) {
            // Webpack 3 returns module.exports as default as module, but webpack 4 returns module.exports as module.default
            return module.default || module;
        });
    },
    isLanguageRegistered: function (instance, language) {
        return !!(0, checkForListedLanguage_1.default)(instance, language);
    },
    languageLoaders: hljs_1.default,
    registerLanguage: function (instance, name, language) {
        return instance.registerLanguage(name, language);
    }
});
//# sourceMappingURL=light-async.js.map